' This script runs a macro on the input file and saves it to an output file. 
' Syntax:
' RunOfficeMacro.vbs 
' 					/Macro:<macro name> 
' 					/InputFile:{inputfilepath} 
' 					/OutputFile:{outputfilepath}

' Example:
' RunOfficeMacro.vbs /Macro:OCRCleaner /InputFile:{inputfilepath} /OutputFile:{outputfilepath}
 

' The Macro must exist in Word, and Word must be executable on the computer running the template script. 
' If it is the server, the server needs to be able to run MS Word, ie.  MS Word needs to be installed and executable.
' The virtual user running the external script on the server can be configured in the memoQ deployment tool. 
' For input and output files simply use the default {inputfilepath} and {outputfilepath} attribute offered by 
' memoQ template editor. 

' In case you want to run an Excel or a PowerPoint macro, edit this script at CreateObject as specified by the comment.

' Before finalizing the memoQ template, run the test feature, so to make sure the script works properly.

Dim appMSApp
Dim docOffice
Dim strMacro, strInputFile, strOutputFile
Dim objArguments

Set objFileSystem = CreateObject("Scripting.FileSystemObject")

' Querying and verifying the arguments of the command

Set objArgumentsNamed = WScript.Arguments.Named
If objArgumentsNamed.Count = 0  Then 
   WScript.Quit(99)
End If

For Each objArgumentNamed in objArgumentsNamed
   Select Case Lcase(objArgumentNamed)
      Case "macro"
         strMacro = LCase(objArgumentsNamed(objArgumentNamed))
      Case "inputfile"
         strInputFile = LCase(objArgumentsNamed(objArgumentNamed))
         
         If Not objFileSystem.FileExists(strInputFile) Then  
            WScript.Quit(3)
         End If
      Case "outputfile"
         strOutputFile = LCase(objArgumentsNamed(objArgumentNamed))
         If objFileSystem.FileExists(strOutputFile) Then  
            WScript.Quit(4)
         End If
      Case Else
         WScript.Quit(5)
   End Select 
Next


If Len(strMacro) > 0 And Len(strInputFile) > 0 And Len(strOutputFile) > 0 Then

' In case of Excel or Powerpoint the attribute of CreateObject needs to be changed to "Excel.Application" or "PowerPoint.Application"

	Set appMSApp = CreateObject("Word.Application") 
	appMSApp.Visible = False
	Set docOffice = appMSApp.Documents.open(strInputFile)

' Running the macro on the specified file within the relevant application and saving the file
	
	appMSApp.Run strMacro
	docOffice.SaveAs strOutputFile, wdFormatDocumentDefault
	appMSApp.Quit

Else

' Ff parameters missing, skip execution
	WScript.Quit(98)

End If

' Clearing variables

Set docOffice = Nothing
Set appMSApp = Nothing
Set strMacro = Nothing
Set strInputFile = Nothing
Set strOutputFile = Nothing
Set objArguments = Nothing

